package com.hxstrive.rabbitmq.controller;

import org.springframework.amqp.core.Message;
import org.springframework.amqp.core.MessageProperties;
import org.springframework.amqp.rabbit.core.RabbitTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

/**
 * RabbitMQ与Spring集成发送消息控制器
 * @author hxstrive.com 2022/2/8
 */
@Controller
@RequestMapping("/rabbitmq")
public class RabbitMqController {

    @Autowired
    private RabbitTemplate rabbitTemplate;

    @ResponseBody
    @RequestMapping("/fanoutSender")
    public String fanoutSender(@RequestParam("message")String message){
        String opt="";
        try {
            String str = "Fanout, The message is : " + message;
            rabbitTemplate.send("fanout-exchange","",
                    new Message(str.getBytes(), new MessageProperties()));
            opt = "success";
        } catch (Exception e) {
            opt = e.getCause().toString();
        }
        return opt;
    }

    @ResponseBody
    @RequestMapping("/topicSender")
    public String topicSender(@RequestParam("message")String message){
        String opt="";
        try {
            String routeKey = "hxstrive.com";
            String str = "The message is [rk:" + routeKey + "][" + message + "]";
            rabbitTemplate.send("topic-exchange", routeKey,
                    new Message(str.getBytes(), new MessageProperties()));

            routeKey = "www.hxstrive.com";
            str = "The message is [rk:" + routeKey + "][" + message + "]";
            rabbitTemplate.send("topic-exchange", routeKey,
                    new Message(str.getBytes(), new MessageProperties()));

            routeKey = "www.hxstrive.net";
            str = "The message is [rk:" + routeKey + "][" + message + "]";
            rabbitTemplate.send("topic-exchange", routeKey,
                    new Message(str.getBytes(), new MessageProperties()));

            opt = "success";
        } catch (Exception e) {
            opt = e.getCause().toString();
        }
        return opt;
    }

}
